//------------------------------------------------------------------------------
// Msrsex1.cs
//
//     This code was generated by the DssNewService tool.
//
//------------------------------------------------------------------------------
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Xml;
using msrsex1 = Robotics.Msrsex1;
using phidgetinterfacekit = Phidgets.Robotics.Services.PhidgetInterfaceKitBoards.Proxy;
using phidgetcommon = Phidgets.Robotics.Services.Proxy;
using gamepad = Microsoft.Robotics.Services.Sample.XInputGamepad.Proxy;


namespace Robotics.Msrsex1
{
    
    /// <summary>
    /// The Msrsex1 Service
    /// </summary>
    [DisplayName("Msrsex1")]
    [Description("The Msrsex1 Service")]
    [Contract(Contract.Identifier)]
    public class Msrsex1Service : DsspServiceBase
    {
        /// <summary>
        /// _state
        /// </summary>
        private Msrsex1State _state = new Msrsex1State();
        /// <summary>
        /// _main Port
        /// </summary>
        [ServicePort("/msrsex1", AllowMultipleInstances=false)]
        private Msrsex1Operations _mainPort = new Msrsex1Operations();

		// our communication port to the Phidget Interface Kit
		[Partner("PhidgetInterfaceKit", Contract = phidgetinterfacekit.Contract.Identifier,
		CreationPolicy = PartnerCreationPolicy.UseExistingOrCreate)]
		private phidgetinterfacekit.PhidgetInterfaceKitBoardsOperations _ikPort = 
			new phidgetinterfacekit.PhidgetInterfaceKitBoardsOperations();

		// our communication port to the gamepad
		[Partner("XInputGamepad", Contract = gamepad.Contract.Identifier,
		CreationPolicy = PartnerCreationPolicy.UseExistingOrCreate)] 
		private gamepad.XInputGamepadOperations _gamepadPort = new gamepad.XInputGamepadOperations(); 

        /// <summary>
        /// Default Service Constructor
        /// </summary>
        public Msrsex1Service(DsspServiceCreationPort creationPort) : 
                base(creationPort)
        {
        }
        /// <summary>
        /// Service Start
        /// </summary>
        protected override void Start()
        {
			base.Start();
			// Add service specific initialization here.

			// subscribe to the attached Phidget device
			// for the moment, we don't specify a request message as it should connect to the one and only Phidget board attached
			// and we don't care about any of the events
            _ikPort.SelectiveSubscribe(null, new phidgetinterfacekit.PhidgetInterfaceKitBoardsOperations());

			// setup a notification port for the Gamepad service
			gamepad.XInputGamepadOperations _gamepadNotify = new gamepad.XInputGamepadOperations();

			// setup handlers for the Gamepad
			Activate(Arbiter.Receive<gamepad.DPadChanged>(true, _gamepadNotify, GamepadDpadHandler));

			// setup handler for the gamepad notifications
            _gamepadPort.Subscribe(_gamepadNotify);
        }
        /// <summary>
        /// Get Handler
        /// </summary>
        /// <param name="get"></param>
        /// <returns></returns>
        [ServiceHandler(ServiceHandlerBehavior.Concurrent)]
        public virtual IEnumerator<ITask> GetHandler(Get get)
        {
            get.ResponsePort.Post(_state);
            yield break;
        }

		// called when we get an update from our Gamepad
		public void GamepadDpadHandler(gamepad.DPadChanged msg)
		{
			gamepad.DPad dpad = msg.Body;

			// turn things on or off based on the state of the D-pad
			SetOutput(0, dpad.Up);
			SetOutput(1, dpad.Down);
			SetOutput(2, dpad.Left);
			SetOutput(3, dpad.Right);
		}

		// enable/disable the relay based on the direction passed
		public void SetOutput(int index, bool enabled)
		{
			// create a new request to send to the Phidgets service
			phidgetcommon.SetOutputRequestType req = new phidgetcommon.SetOutputRequestType();

			// assign the index and state (true/false)
			req.Index = index;
			req.State = enabled;

			// send the request to the port
			_ikPort.SetOutput(req);
		}
    }
}
